#include <Array.au3>

#cs

	gtt_src_glosscheck v1
	2012 Samuel Murray

#ce

Global $savefileopen
Global $i
Global $fileread
Global $firstsplit
Global $msgnum
Global $msgtxt
Global $msgtxtA
Global $msgtxtB
Global $msgkillcomment
Global $msgkillspans
Global $msgclean
Global $fileopendialog
Global $openfileopen
Global $savefiledialog
Global $cleantext

Global $glossaryfileopen, $glossaryfileread, $glossarylines, $glossarycolumn, $glosscycle, $glossarylinesplit, $glossaryrule, $glossarycomment, $msgreallyclean, $therescomment, $termschecked, $joinings, $joins

; 1. User gives the glossary file (TXT)

$glossaryfileopendialog = FileOpenDialog("Select glossary", @ScriptDir, "Text files (*.txt)|All files (*.*)", 3, "glossary.txt")

$glossaryfileopen = FileOpen($glossaryfileopendialog, 128)
$glossaryfileread = FileRead($glossaryfileopen)
$glossarylines = StringSplit($glossaryfileread, @CRLF, 1)

; 2. User gives output file

$fileopendialog = FileOpenDialog("Select SRC output file", @ScriptDir, "TXT files (*.txt)|All files (*.*)", 1)
$openfileopen = FileOpen($fileopendialog, 128)
$fileread = FileRead($openfileopen)

$fileopendialogfileonly = StringRegExpReplace($fileopendialog, ".+\\", "")

$filesavedialog = FileSaveDialog("Select a name for the report file", @ScriptDir, "HTML files (*.html)|All files (*.*)", 18, $fileopendialogfileonly & "_report.htm")

$savefileopen = FileOpen($filesavedialog, 130)

; 3. Then compiling the HTML file...

FileWrite($savefileopen, '<head><style>' & @CRLF & '<!--' & @CRLF & 'span.tw4winMark {mso-style-name:tw4winMark; mso-style-parent:""; mso-ansi-font-size:12.0pt; font-family:Arial; mso-ascii-font-family:Arial; mso-hansi-font-family:Arial; color:green; display:none; mso-hide:all; mso-no-proof:yes; vertical-align:sub;}' & @CRLF & 'span.tw4winError {mso-style-name:tw4winError; mso-style-parent:""; mso-ansi-font-size:20.0pt; font-family:Arial; mso-ascii-font-family:Arial; mso-hansi-font-family:Arial; color:aqua;}' & @CRLF & 'span.tw4winPopup {mso-style-name:tw4winPopup; mso-style-parent:""; font-family:Arial; mso-ascii-font-family:Arial; mso-hansi-font-family:Arial; color:teal; mso-ansi-language:#0400; mso-no-proof:yes;}' & @CRLF & 'span.tw4winJump {mso-style-name:tw4winJump; mso-style-parent:""; font-family:Arial; mso-ascii-font-family:Arial; mso-hansi-font-family:Arial; color:navy; mso-ansi-language:#0400; mso-no-proof:yes;}' & @CRLF & 'span.tw4winExternal {mso-style-name:tw4winExternal; mso-style-parent:""; mso-ansi-font-size:12.0pt; font-family:Arial; mso-ascii-font-family:Arial; mso-hansi-font-family:Arial; color:gray; mso-ansi-language:#0400; mso-no-proof:yes;}' & @CRLF & 'span.tw4winInternal {mso-style-name:tw4winInternal; mso-ansi-font-size:12.0pt; font-family:"Niagara Solid"; mso-ascii-font-family:"Niagara Solid"; mso-hansi-font-family:"Niagara Solid"; mso-ansi-language:ZU; mso-no-proof:yes;}' & @CRLF & 'span.tw4winTerm {mso-style-name:tw4winTerm; mso-style-parent:""; color:black;}' & @CRLF & 'span.DONOTTRANSLATE {mso-style-name:DO_NOT_TRANSLATE; mso-style-parent:""; font-family:Arial; mso-ascii-font-family:Arial; mso-hansi-font-family:Arial; color:purple; mso-ansi-language:#0400; mso-no-proof:yes;}' & @CRLF & ' -->' & @CRLF & '</style></head><body>' & @CRLF & @CRLF & '<table border="1" cellpadding="10" cellspacing="0" >' & @CRLF)

FileWrite($savefileopen, '<tr><td width="10%" bgcolor="#ADD8E6">Msg&nbsp;#</td><td bgcolor="#ADD8E6">Source&nbsp;text</td><td width="33%" bgcolor="#ADD8E6">Glossary&nbsp;matches&nbsp;matches</td></tr>' & @CRLF)

; 4. Split the old output file by line, then split it by tab

$filereadsplit = StringSplit($fileread, @CRLF, 1)

For $i = 1 To $filereadsplit[0]

	$filelinesplit = StringSplit($filereadsplit[$i], @TAB, 1)

	If $filelinesplit[0] = 2 Then

		FileWrite($savefileopen, "<tr>" & @CRLF)

		; 4.1 Message number is 1st column

		FileWrite($savefileopen, "<td>" & $filelinesplit[1] & "</td>" & @CRLF)

		; 4.3 Convert the variables

		$msgclean = $filelinesplit[2]

		$msgclean = StringReplace($msgclean, '{{', "{{<span class=tw4winInternal><span lang=ZU style='mso-ansi-language:ZU;mso-no-proof:yes'>")
		$msgclean = StringReplace($msgclean, '}}', '</span></span>}}')

		; 4.4 Colour spaces next to variables

		If StringInStr($msgclean, ' {{') Then
			$msgclean = StringReplace($msgclean, ' {{', '<span style="background-color: #FFFF00"> </span>{{')
		EndIf
		If StringInStr($msgclean, '}} ') Then
			$msgclean = StringReplace($msgclean, '}} ', '}}<span style="background-color: #FFFF00"> </span>')
		EndIf

		; 4.5 Finally, colour the variables

		$msgclean = StringReplace($msgclean, '{{', '{{<span style="color: #808080">')
		$msgclean = StringReplace($msgclean, '}}', '}}</span>')

; 4.5.1 (for gloss checking, keep version of variable with curly brackets

$msgcleanish = $msgclean

; 4.5.2 Finally, convert the curly brackets to boxes

		$msgclean = StringReplace($msgclean, '{{', '<span style="border-top:solid;border-left: none;border-bottom:solid;border-right:none windowtext 1.0pt;mso-border-alt: solid windowtext .5pt;padding:0cm">[')
		$msgclean = StringReplace($msgclean, '}}', ']</span>')

		#cs
			; 4.6. Check for leading, trailing and doubled spaces

			If StringLeft($msgclean, 1) = " " Then
			$msgclean = StringTrimLeft($msgclean, 1)
			$msgclean = '<span style="background-color: #FF0000">&nbsp;</span>' & $msgclean
			EndIf

			If StringRight($msgclean, 1) = " " Then
			$msgclean = StringTrimRight($msgclean, 1)
			$msgclean = $msgclean & '<span style="background-color: #FF0000">&nbsp;</span>'
			EndIf

			If StringInStr($msgclean, '  ') Then
			$msgclean = StringReplace($msgclean, '  ', '<span style="background-color: #FF0000">&nbsp;&nbsp;</span>')
			EndIf
		#ce

		#cs (from blacklist script)
			; 4.7 Colour the joining-s possibles

			$joins = StringSplit("([a-z]skap[a-r,t-z][a-z][a-z][a-z])|([a-z]heid[a-r,t-z][a-z][a-z][a-z])|([a-z]ing[a-r,t-z][a-z][a-z][a-z])|([a-z]teit[a-r,t-z][a-z][a-z][a-z])|([a-r,t-z]halwe)|([a-r,t-z]waardig)|([a-r,t-z]we)|([a-r,t-z]gesind)", "|", 1)

			For $joinings = 1 To 8

			If StringRegExp($msgclean, $joins[$joinings], 0) = 1 Then
			$msgclean = StringRegExpReplace($msgclean, $joins[$joinings], '<span style="color: #0000FF; font-weight: bold">' & '$1' & '</span>')

			EndIf

			Next
		#ce

		; 4.8 Finally write this to the third column...

		FileWrite($savefileopen, "<td><span lang=AF style='mso-ansi-language:AF'>" & $msgclean & "</span>" & @CRLF)

		; 5. Then do the glossary

		; First, clean the text of all tags

		$msgreallyclean = StringRegExpReplace($msgcleanish, "\{\{.+?\}\}", "{0}")
		$msgreallyclean = StringRegExpReplace($msgreallyclean, "\<.+?\>", "")

		$glossary1column = "FIRSTLINETOBEREMOVED<br>" ; whole word

		For $glosscycle = 1 To $glossarylines[0]

			If StringInStr($glossarylines[$glosscycle], @TAB) Then

				; 5.1 Define the three columns

				$glossarylinesplit = StringSplit($glossarylines[$glosscycle], @TAB, 1)
				If $glossarylinesplit[0] = 2 Then ; then there's no comment
					$therescomment = 0
					$glossarySL = $glossarylinesplit[1]
					$glossaryTL = $glossarylinesplit[2]
				ElseIf $glossarylinesplit[0] > 2 Then ; then there's a comment
					$glossarySL = $glossarylinesplit[1]
					$glossaryTL = $glossarylinesplit[2]
					$glossarycomment = $glossarylinesplit[3]
					$therescomment = 1
				Else ; else not a valid entry
					ContinueLoop
				EndIf

				; 5.2 Do whole-word matching

				If StringLen($glossarySL) < 2 Then
					ContinueLoop
				Else

					If StringRegExp($msgreallyclean, "\b" & $glossarySL & "\b") Then
						If $therescomment = 1 Then
							$glossary1column = $glossary1column & '<span style="color: #0000FF">[W]</span>&nbsp;<b><font color=black>' & $glossarySL & ' :: </font><font color=red>' & $glossaryTL & '</font></b><br><i><font size="-1">' & $glossarycomment & '</font></i><br><br>'
						ElseIf $therescomment = 0 Then
							$glossary1column = $glossary1column & '<span style="color: #0000FF">[W]</span>&nbsp;<b><font color=black>' & $glossarySL & ' :: </font><font color=red>' & $glossaryTL & '</font></b><br><br>'
						EndIf
					Else

						If StringRegExp($msgreallyclean, $glossarySL) Then
							If $therescomment = 1 Then
								$glossary1column = $glossary1column & '[N]&nbsp;<b><font color=black>' & $glossarySL & ' :: </font><font color=red>' & $glossaryTL & '</font></b><br><i><font size="-1">' & $glossarycomment & '</font></i><br><br>'
							ElseIf $therescomment = 0 Then
								$glossary1column = $glossary1column & '[N]&nbsp;<b><font color=black>' & $glossarySL & ' :: </font><font color=red>' & $glossaryTL & '</font></b><br><br>'
							EndIf

						EndIf

					EndIf

				EndIf

			EndIf

		Next

		$glossary1column = StringReplace($glossary1column, "FIRSTLINETOBEREMOVED<br>", "")

		If StringRight($glossary1column, 4) = "<br>" Then
			$glossary1column = StringTrimRight($glossary1column, 4)
		EndIf

		FileWrite($savefileopen, "<td><span lang=ZU style='mso-ansi-language:ZU;mso-no-proof:yes'>" & $glossary1column & "&nbsp;</span></td>" & @CRLF)

		FileWrite($savefileopen, "</tr>" & @CRLF)

	Else

		FileWrite($savefileopen, "<tr>" & @CRLF)
		FileWrite($savefileopen, "<td colspan=4>[Could not process line, for some reason]</td>" & @CRLF)
		FileWrite($savefileopen, "</tr>" & @CRLF)

	EndIf

Next

FileWrite($savefileopen, "</table></body></html>")

MsgBox(0, "Done", "Did " & $i & " segments.", 0)