#include <Array.au3>

Global $savefileopen
Global $i
Global $fileread
Global $firstsplit
Global $msgnum
Global $msgtxt
Global $msgclean
Global $fileopendialog
Global $openfileopen
Global $savefiledialog
Global $cleantext
Global $unlinebreak
Global $tabby

; 1. User gives the source text file (HTML or TXT)

$fileopendialog = FileOpenDialog ("Select GTT source file", @ScriptDir, "All files (*.*)|Text files (*.txt)|HTML files (*.html)", 3)

$fileopendialogfileonly = StringRegExpReplace ($fileopendialog, ".+\\", "")

; 2. User gives name for output file

$filesavedialog = FileSaveDialog ("Name the output file", @ScriptDir, "All files (*.*)|Text files (*.txt)|HTML files (*.html)", 18, $fileopendialogfileonly & "_output.txt")

; 3. Script opens the two files

$openfileopen = FileOpen ($fileopendialog, 128)
$fileread = FileRead ($openfileopen)

$savefileopen = FileOpen ($filesavedialog, 130)

; 4. Split input file by message (raw)

; OLD LINE $firstsplit = StringSplit ($fileread, 'class="gtc-noSplit"><span id="goog-gtc-unit-', 1) ; to determine number of strings
$firstsplit = StringSplit ($fileread, '<span id="goog-gtc-unit-', 1) ; to determine number of strings

For $i = 2 to $firstsplit[0]

; 5. Get the message number ($msgnum[1])

$msgnum = StringSplit ($firstsplit[$i], '"', 1)

; 6.1 Get the raw text

If StringInStr ($firstsplit[$i], 'goog-gtc-translatable') Then ; then there is text

; FROM THIS POINT, VERSION 5 IS DIFFERENT -- IT FIRST CONVERTS PLACEABLES AND LINE BREAKS

; 6.4 Convert placeables

; 6.4.1 Move numbered placeables out of spans

#cs
OLD VERSION
If StringRegExp ($firstsplit[$i], '(<span class="notranslate" id="ph-)(\d+)(">)') Then
$firstsplit[$i] = StringRegExpReplace ($firstsplit[$i], '(<span class="notranslate" id="ph-)(\d+)(">)', '<span class="notranslate">$2:')
EndIf
#ce

If StringRegExp ($firstsplit[$i], '(<span class="notranslate" id="ph-)(\d+)(">)') Then
$firstsplit[$i] = StringRegExpReplace ($firstsplit[$i], '(<span class="notranslate" id="ph-)(\d+)(">)', '<span class="notranslate">$2:')
ElseIf StringRegExp ($firstsplit[$i], '(<span id="ph-)(\d+)(" class="notranslate">)') Then
$firstsplit[$i] = StringRegExpReplace ($firstsplit[$i], '(<span id="ph-)(\d+)(" class="notranslate">)', '<span class="notranslate">$2:')
EndIf

; 6.4.2 Convert spans to brackets

$firstsplit[$i] = StringRegExpReplace ($firstsplit[$i], '(<span class="notranslate">)(.+?)(</span>)', '{{$2}}')

; FROM HERE THE SCRIPT IS DIFFERENT FROM SRC SCRIPT

; 6.1.1 Get status indicators

$msgtxtA = StringSplit ($firstsplit[$i], 'goog-gtc-translatable', 1)
; So status plus text  = $msgtxtA[2]

$msgtxtB = StringSplit ($msgtxtA[2], '">', 1)
; so status = $msgtxtB[1]
; so text = all the rest

; 6.1.2 Process the status indicators

If StringInStr ($msgtxtB[1], "goog-gtc-") Then
$msgtxtB[1] = StringReplace ($msgtxtB[1], "goog-gtc-", "")
EndIf

If StringInStr ($msgtxtB[1], "from-mt") Then
$msgtxtB[1] = StringReplace ($msgtxtB[1], "from-mt", "machine")
EndIf

If StringInStr ($msgtxtB[1], "from-source") Then
$msgtxtB[1] = StringReplace ($msgtxtB[1], "from-source", "untranslated")
EndIf

If StringInStr ($msgtxtB[1], "from-human") Then
$msgtxtB[1] = StringReplace ($msgtxtB[1], "from-human", "human")
EndIf

If StringInStr ($msgtxtB[1], "from-tm") Then
$msgtxtB[1] = StringReplace ($msgtxtB[1], "from-tm", "")
EndIf

If StringInStr ($msgtxtB[1], "-score-") Then
$msgtxtB[1] = StringReplace ($msgtxtB[1], "-score-", "from-tm-")
EndIf

If StringInStr ($msgtxtB[1], "100-fuzzy") Then
$msgtxtB[1] = StringReplace ($msgtxtB[1], "100-fuzzy", "99")
EndIf

If StringInStr ($msgtxtB[1], "ph-missing") Then
$msgtxtB[1] = StringReplace ($msgtxtB[1], "ph-missing", 'PLACEABLE_ERROR')
EndIf

$statusindicator = $msgtxtB[1]
$statusindicator = StringRegExpReplace ($statusindicator, "\s*?", "")

; 6.1.3 Reconcatenate the text (since we unfortunately split it using ">)

If $msgtxtB[0] > 2 Then
$msgclean = _ArrayToString($msgtxtB, '">', 2)
Else
$msgclean = $msgtxtB[2]
EndIf

; 6.2 Get the raw text, step 2

; 6.2.1 Deal with comments, or clear off end spans

If StringInStr ($msgclean, "goog-gtc-comments") Then
MsgBox (0, "!!!", "This file has comments, please fix AU script first.", 0)
$msgkillcomment = StringSplit ($msgclean, '</span><span class="goog-gtc-comments">', 1)
; so now $msgkillcomment[1] is the clean text
$msgclean = $msgkillcomment[1]
$rawcomment = $msgkillcomment[2]
$iscomment = 1
Else
; OLD $msgclean = StringRegExpReplace ($msgclean, '(</span></span>)(\s*?)(</div>)', "$1$3")
; OLD $msgkillspans = StringSplit ($msgclean, '</span></span></div>', 1)
$msgkillspans = StringSplit ($msgclean, '</span></span>', 1)
$msgclean = $msgkillspans[1]
$iscomment = 0
EndIf

$rawtext2 = $msgclean

; 6.3 Convert line breaks

$rawtext3 = StringReplace ($rawtext2, @CRLF, '{{!LF}}')

; FROM HERE SCRIPT IS ALMOST SAME AS SRC SCRIPT AGAIN

; 6.5 Convert HTML entities

$rawtext5 = StringReplace ($rawtext3, "&#39;", "'")
$rawtext5 = StringReplace ($rawtext5, "&lt;", "<")
$rawtext5 = StringReplace ($rawtext5, "&gt;", ">")
$rawtext5 = StringReplace ($rawtext5, "&apos;", "'")
$rawtext5 = StringReplace ($rawtext5, '&quot;', '"')
$rawtext5 = StringReplace ($rawtext5, "&amp;", "&")

; 7. Grab descriptions
; Description and Placeable meaning extraction not supported
; in this version of the script because it is not necessary.

$cleantext = $rawtext5

; 8. Convert comments
; Comments to be converted in a later version of the sript.

Else
$cleantext = "!!!NO TRANSLATABLE TEXT!!!"
Endif

FileWrite ($savefileopen, $msgnum[1] & @TAB & $statusindicator & @TAB & $cleantext & @CRLF)

Next

MsgBox (0, "Done", "Did " & $i & " segments.", 0)